From e4347d916140b263ad5f084b349ed81f7381f62a Mon Sep 17 00:00:00 2001
From: Chizi123 <build@jsrv.com>
Date: Mon, 19 Oct 2020 07:13:17 +0000
Subject: [PATCH] removed testing line and fixed typo

---
 main.sh |  101 ++++++++++++++++++++++++++++++--------------------
 1 files changed, 61 insertions(+), 40 deletions(-)

diff --git a/main.sh b/main.sh
index 7e7f635..09af3a7 100755
--- a/main.sh
+++ b/main.sh
@@ -9,34 +9,34 @@
 # Usage: newold_matching_file [n/o] [filename]
 function newold_matching_file
 {
-    # Use ${1-} instead of $1 in case 'nounset' is set
-    local -r glob_pattern=${2-}
+	# Use ${1-} instead of $1 in case 'nounset' is set
+	local -r glob_pattern=${2-}
 
-    # To avoid printing garbage if no files match the pattern, set
-    # 'nullglob' if necessary
-    local -i need_to_unset_nullglob=0
-    if [[ ":$BASHOPTS:" != *:nullglob:* ]] ; then
-        shopt -s nullglob
-        need_to_unset_nullglob=1
-    fi
+	# To avoid printing garbage if no files match the pattern, set
+	# 'nullglob' if necessary
+	local -i need_to_unset_nullglob=0
+	if [[ ":$BASHOPTS:" != *:nullglob:* ]] ; then
+		shopt -s nullglob
+		need_to_unset_nullglob=1
+	fi
 
-    file=
-    for f in $glob_pattern ; do
+	file=
+	for f in $glob_pattern ; do
 		if [ $1 == "n" ]; then
 			[[ -z $f || $f -nt $_file ]] && file=$f
 		elif [ $1 == "o" ]; then
 			[[ -z $f || $f -ot $_file ]] && file=$f
 		fi
-    done
+	done
 
-    # To avoid unexpected behaviour elsewhere, unset nullglob if it was
-    # set by this function
-    (( need_to_unset_nullglob )) && shopt -u nullglob
+	# To avoid unexpected behaviour elsewhere, unset nullglob if it was
+	# set by this function
+	(( need_to_unset_nullglob )) && shopt -u nullglob
 
-    # Use printf instead of echo in case the file name begins with '-'
-    [[ -n $file ]] && printf '%s\n' "$file"
+	# Use printf instead of echo in case the file name begins with '-'
+	[[ -n $file ]] && printf '%s\n' "$file"
 
-    return 0
+	return 0
 }
 
 #Build latest version of a package
@@ -66,25 +66,34 @@
 		return 1
 	fi
 
-	#Get build artifact names
+	#Get build artifact names from PKGBUILD and build artifacts
+	#Remove duplicates from the list
 	source PKGBUILD
 	pkgs=()
+	ipkgs=()
 	for i in ${pkgname[@]}; do
 		#pkgs+=("$i-$pkgver-$pkgrel")
-		pkgs+=("$(find . -mindepth 1 -maxdepth 1 -type f -name "$1*.tar.*" -not -name "*.sig" | sed 's/^\.\///')")
+		ipkgs+=($(find . -mindepth 1 -maxdepth 1 -type f \( -name "$i*.pkg.tar.*" -o -name "$i*.src.tar.*" \) -not -name "*.sig" | sed 's/^\.\///'))
 	done
+	while read -r -d '' x; do pkgs+=("$x"); done < <(printf "%s\0" "${ipkgs[@]}" | sort -uz)
 
 	#Move package to repodir and add to repo db
 	#Dont change the database if rebuilt the same package at same release and version
+	flag=0
 	for i in ${pkgs[@]}; do
-		if [[ -f $REPODIR/$i ]]; then
-			pkgs=${pkgs[@]/$i}
-		else
-			rm -f $REPODIR/*$1*.tar.*
-			cp $i $REPODIR/
-			[[ "$SIGN" == "Y" ]] && cp $i.sig $REPODIR/
+		if [[ ! -f $REPODIR/$i ]]; then
+			flag=1
 		fi
 	done
+	if [[ $flag == 1 ]]; then
+		rm -f $REPODIR/*$1*.tar.*
+		for i in ${pkgs[@]}; do
+			cp $i $REPODIR/
+			[[ "$SIGN" == "Y" ]] && cp $i.sig $REPODIR/
+		done
+	else 
+		return;
+	fi
 
 	# Weird exceptions
 	if [[ "$1" == "zoom" ]]; then
@@ -105,9 +114,9 @@
 	while true; do
 		# Wait until package is at the top of the queue and add to db
 		if [[ "$(head -n1 $REPODIR/.waitlist)" == "$1" ]]; then
-			for i in ${pkgs[@]}; do
-				repo-add $([[ "$SIGN" == "Y" ]] && echo "--sign --key $KEY") $REPODIR/$REPONAME.db.tar.$([ -n COMPRESSION ] || echo $COMPRESSION && echo zst) $REPODIR/$i
-			done
+		#	for i in ${pkgs[@]}; do
+				repo-add $([[ "$SIGN" == "Y" ]] && echo "--sign --key $KEY") $REPODIR/$REPONAME.db.tar.$([ -n "$COMPRESSION" ] || echo $COMPRESSION && echo zst) ${pkgs[@]}
+		#	done
 			while true; do
 				if [[ $(cat $REPODIR/.waitlist.lck) == 1 ]]; then
 					sleep 1
@@ -141,8 +150,8 @@
 	#Currently old package versions stay in the repodir indefinately
 	# while [ $NUM_OLD \< $(find . -name '*.pkg.tar.xz' | wc -l) ]
 	# do
-	# 	old=$(newold_matching_file o '*.pkg.tar.xz')
-	# 	rm $REPODIR/$old $old
+	#	old=$(newold_matching_file o '*.pkg.tar.xz')
+	#	rm $REPODIR/$old $old
 	# done
 	return 0
 }
@@ -173,7 +182,7 @@
 }
 
 #Add a new package to be built
-#Adding build dependencies is 
+#Adding build dependencies is
 # Usage: add [package name]
 function add {
 	for i in $@; do
@@ -187,7 +196,7 @@
 
 		#check for all build dependencies
 		for i in ${makedepends[@]}; do
-			if pacman -Si $i; then 
+			if pacman -Si $i; then
 				makedepends=${makedepends[@]/$delete}
 			fi &>/dev/null
 		done
@@ -205,13 +214,26 @@
 }
 
 #Remove a package from the build list and repository
-# Usage remove [package name]
+#Usage of -a removes all packages moved to official repos
+# Usage remove [-a|package name]
 function remove {
-	for i in $@; do
-		rm -rf $BUILDDIR/$i
-		repo-remove $REPODIR/$REPONAME.db.tar.xz $i
-		rm -f $REPODIR/*$i*
-	done
+	if [[ "$1" == "-a" ]]; then
+		rmlist=""
+		rmlist="$rmlist $(comm -12 <(pacman -Slq $REPONAME | sort) <(pacman -Slq core | sort) | tr '\n' ' ')"
+		rmlist="$rmlist $(comm -12 <(pacman -Slq $REPONAME | sort) <(pacman -Slq extra | sort) | tr '\n' ' ')"
+		rmlist="$rmlist $(comm -12 <(pacman -Slq $REPONAME | sort) <(pacman -Slq community | sort) | tr '\n' ' ')"
+		for i in $rmlist; do
+			rm -rf $BUILDDIR/$i
+			repo-remove $([[ "$SIGN" == "Y" ]] && echo "--sign --key $KEY") $REPODIR/$REPONAME.db.tar.$([ -n "$COMPRESSION" ] || echo $COMPRESSION && echo zst) $i
+			rm -f $REPODIR/*$i*
+		done
+	else
+		for i in $@; do
+			rm -rf $BUILDDIR/$i
+			repo-remove $([[ "$SIGN" == "Y" ]] && echo "--sign --key $KEY") $REPODIR/$REPONAME.db.tar.$([ -n "$COMPRESSION" ] || echo $COMPRESSION && echo zst) $i
+			rm -f $REPODIR/*$i*
+		done
+	fi
 }
 
 #Check config and create build folders
@@ -295,4 +317,3 @@
 else
 	echo "All packages built successfully"
 fi
-

--
Gitblit v1.9.3